{
        ltalnos rutinok a Listazasok alkalmazshoz:
  Ef:
    uses ComCtrls, FoAblak;
}

  Function SokJel(Const jel:Char; db:Byte):String;
    Var i:Byte;
        s:String;
  Begin
    s:=''; For i:=1 to db do s:=s+jel;
    SokJel:=s
  End;//SokJel

  Function Kozepre(Const s:String; h:integer):String;
  (*
    Ef: h>=length(s)
  *)
  Begin
    Kozepre:=Copy(SokJel(' ',(h-Length(s)) Div 2)
                  +s+
                  SokJel(' ',(h-Length(s)) Div 2)+'  ',1,h)
  End;//Kozepre

  Procedure LapAlja;
    var
      i:integer;
  begin
    for i:=sor+1 to lapHossz-1 do fmFoAblak.mmOutput.Append(' ');//res sorok
    //lblc:
    fmFoAblak.mmOutput.Append(Kozepre(intToStr(lapSzam),sorHossz));
  end;//LapAlja
  
  Procedure Lapoz;
    var
      s:string;
  Begin
    s:=' '+'|'+
       Kozepre('nv',nevH)+'|'+
       Kozepre('cm',cimH)+'|'+
       Kozepre('tel.',telH)+'|'+
       Kozepre('fizu.',fizuH);
    fmFoAblak.mmOutput.Append(s);
    inc(lapSzam); sor:=1;
  End;//Lapoz

  Procedure ElemKi(Const e:TElem);
    var
      s:string;
  Begin
    If sor=lapHossz-1 {Lblcnek mg ki kell frnie} then
    Begin
      LapAlja; Lapoz;
    End;
    If e.szintKod=Dolgozo then
    Begin
(*
        Kirandk:
        KSzint[e.szintKod] + e.nev + e.cim + e.tel + intToStr(e.fiz)
*)
      s:=KSzint[e.szintKod]+SokJel(' ',szintKodH-length(KSzint[e.szintKod]))+'|'+
         e.nev+SokJel(' ',nevH-length(e.nev))+'|'+
         e.cim+SokJel(' ',cimH-length(e.Cim))+'|'+
         e.tel+SokJel(' ',telH-length(e.tel))+'|'+
         SokJel(' ',fizuH-length(intToStr(e.fiz)))+intToStr(e.fiz);
    End
      else
    Begin
(*
        Kirandk:
        KSzint[e.szintKod] + e.nev, e.cim + e.tel + intToStr(e.fiz) +
        If e.fiz<>0 then intToStr(e.fiz) else ''
*)
      s:=KSzint[e.szintKod]+SokJel(' ',szintKodH-length(KSzint[e.szintKod]))+'|'+
         e.nev+SokJel(' ',nevH-length(e.nev))+'|'+
         e.cim+SokJel(' ',cimH-length(e.Cim))+'|'+
         e.tel+SokJel(' ',telH-length(e.tel))+'|';
      If e.fiz<>0 then s:=s+SokJel(' ',fizuH-length(intToStr(e.fiz)))+intToStr(e.fiz);
    End;//If
    fmFoAblak.mmOutput.Append(s);
    Inc(sor);
  End;//ElemKi

  Procedure Inic;
  Begin
    sor:=0; lapSzam:=0;
    fmFoAblak.mmOutput.Clear;
  End;//Inic
{
        Alap file-kezel rutinok:
}
  Procedure Megnyit(Var f:TFile; Const fN:string; Const mire:TMegnyitasMod);
  (*
    Ef: megnyitsi problma nem lehet
  *)
  Begin
    If mire=Olvasas then
    Begin
      Assign(f,fN); Reset(f);
    end
      else
    Begin
      Assign(f,fN); Rewrite(f);
    End;
  End;//Megnyit

  Procedure Lezar(Var f:TFile);
  Begin
    CloseFile(f)
  End;//Lezar
{
        Generl rutinok:
}
  procedure general(const fN:string);
    Var
      f:TFile;
      elem:TElem;

    Procedure DolgozotGeneral(Var d:TElem);
      Const
        MinFizu=20000;
    Begin
      d.szintkod:=Dolgozo;
      d.nev:=RandomNev; d.cim:=RandomCim; d.tel:=RandomTel;
      d.fiz:=MinFizu+3000*Trunc(1.0*Random(MinFizu Div 1000));
    End;{DolgozotGeneral}

    Procedure TanszeketGeneral(Const tsz:String; Var elem:TElem);
    (*
      Ef: LapHossz>=minLapHossz
    *)
      Var
        i,Db:Word;
    Begin
      elem.szintkod:=Tanszek;
      elem.nev:=tsz; elem.cim:=RandomCim; elem.tel:=RandomTel; elem.fiz:=0;
      Write(f,elem);
      {egy tanszk ltszma:
       a tbblet (nyit- vagy zr-) rekordok (<=4) +
       a lap fej-lblce (=2) + minimlis ltszm (=2)
       miatt: MinTanszLetsz..MinTanszLetsz+LapHossz-4-2-MinTanszLetsz+1
       minLapHossz=4+2+MinTanszLetsz, lsd FoAblak-ban}
      Db:=MinTanszLetsz+Random(LapHossz-minLapHossz+1);
      For i:=1 to Db do
      Begin
        DolgozotGeneral(elem);
        Write(f,elem)
      End;
    End;{TanszeketGeneral}

  Begin{general}
    assignFile(f,fN);
    rewrite(f);
   {egyetem:}
    elem.szintkod:=Egyetem;
    elem.nev:='ELTE'; elem.cim:=RandomCim; elem.tel:=RandomTel; elem.fiz:=0;
    Write(f,elem);
   {Egy kar:}
    elem.szintkod:=Kar;
    elem.nev:='TTK'; elem.cim:=RandomCim; elem.tel:=RandomTel; elem.fiz:=0;
    Write(f,elem);
   {Egy tanszk:}
    TanszeketGeneral('Informatika Szakmdszertani',elem);
   {Egy tanszk:}
    TanszeketGeneral('Numerikus analizis',elem);
   {Egy tanszk:}
    TanszeketGeneral('Szmitstudomnyi',elem);
   {Egy tanszk:}
    TanszeketGeneral('Analizis',elem);
   {Egy tanszk:}
    TanszeketGeneral('Algebra',elem);
   {Egy tanszk:}
    TanszeketGeneral('Elmleti fizika',elem);
   {Egy kar:}
    elem.szintkod:=Kar;
    elem.nev:='BTK'; elem.cim:=RandomCim; elem.tel:=RandomTel; elem.fiz:=0;
    Write(f,elem);
   {Egy tanszk:}
    TanszeketGeneral('Angol',elem);
   {Egy tanszk:}
    TanszeketGeneral('Keleti nyelvek',elem);
   {Egy tanszk:}
    TanszeketGeneral('Hungarolgia',elem);
   {Egy tanszk:}
    TanszeketGeneral('Filozfia',elem);

    closeFile(f);
  End;//general
{
        Diagnosztikus rutinok:
}
  function maxTanszekMeret(const fN:string):integer;
  (*
    A fjlban lv legnpesebb tanszk ltszma
  *)
    var
      f:TFile;
      elem:TElem;
      lsz,maxLsz:Integer;
  Begin
    assignFile(f,fN);
    reset(f);
    maxLsz:=0;
    //nyitrekordok tlpse:
    Read(f,elem); Read(f,elem); Read(f,elem);
    While not Eof(f) do
    Begin
      Read(f,elem);
      lsz:=0;
      While not Eof(f) and (elem.szintKod=Dolgozo) do
      Begin
        Inc(lsz); Read(f,elem);
      End;//While
      If Eof(f) then Inc(lsz);//fjlvgi korrekci
      If lsz>maxLsz then maxLsz:=lsz;
    End;//While
    closeFile(f);
    MaxTanszekMeret:=maxLsz;
  End;//maxTanszekMeret

  
