unit GeneralParameterAblak;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons;

type

  { TfmGeneralParameter }

  TfmGeneralParameter = class(TForm)
    bbKesz: TBitBtn;
    leLaphossz: TLabeledEdit;
    procedure bbKeszClick(Sender: TObject);
    procedure leLaphosszExit(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  fmGeneralParameter: TfmGeneralParameter;

implementation

{ TfmGeneralParameter }

uses
  FoAblak{<=sbAllapotok}, Listazas {<=lapHossz};
  
procedure TfmGeneralParameter.leLaphosszExit(Sender: TObject);
  var
   lh:integer;
begin
  try
    fN:=''; fmFoAblak.FormCreate(Sender);
    lh:=strToInt(leLapHossz.Text);
    if (lh<minLapHossz) or (lh>MaxLapHossz) then
    begin
      leLapHossz.SetFocus;
      leLapHossz.Color:=clRed;
    end
      else
    begin
      lapHossz:=lh;
      leLapHossz.Color:=clWindow;
      fmFoAblak.sbAllapotok.Panels.Items[1].Text:=intToStr(lapHossz);
    end;//if
  except
    leLapHossz.SetFocus;
    leLapHossz.Color:=clRed;
  end
end;//TfmGeneralParameter.leLaphosszExit

procedure TfmGeneralParameter.bbKeszClick(Sender: TObject);
begin
 if leLapHossz.Color=clRed then leLapHossz.SetFocus
                           else fmGeneralParameter.Visible:=false;
end;//TfmGeneralParameter.bbKeszClick

initialization
  {$I generalparameterablak.lrs}

end.

